<template>
  <div class="blok_card_contener">
    <v-card class="header_card">
      <div class="burger">
        <NavBar />
      </div>
      <div class="anime_headr">
        <div class="icon">
          <h1>
            <a class="a1" href="/">
              <div class="waviy">World of fantasy</div>
            </a>
          </h1>
        </div>
      </div>
      <v-tabs v-model="tab" color="red">
        <router-link to="/anime" class="text-decoration-none"
          ><v-tab>Anime</v-tab></router-link
        >
        <router-link to="/manga" class="text-decoration-none"
          ><v-tab>Manga</v-tab></router-link
        >
      </v-tabs>
      <div class="button_search">
        <div class="search-box">
          <router-link :to="{ path: '', query: { search: input } }">
            <button @click="testFunction" class="btn-search">
              <img src="../src/assets/img/icons8-search.svg" alt="Search" />
            </button>
          </router-link>
          <input
            @keyup.enter="testFunction"
            v-model="input"
            type="text"
            class="input-search"
            placeholder="Search..."
          />
        </div>
      </div>
    </v-card>
    <div class="contener"><router-view></router-view></div>
    <footer>
      <div class="pagePath">
        <router-link :to="{ path: '', query: { page: page } }">
          <vs-pagination
            :total="paginationStore.lastPage"
            :max="this.maxPage"
            v-model="page"
            prev-icon="arrow_back"
            next-icon="arrow_forward"
            goto
            @click="testPage"
          ></vs-pagination
        ></router-link>
      </div>
      <div id="scrollToTop" @click="scrollToTop">
        <ChevronUpCircle :size="55" color="#ffffff" :stroke-width="0.9" />
      </div>
    </footer>
  </div>
</template>

<script>
import { ChevronUpCircle } from 'lucide-vue-next';
import NavBar from './components/NavBar.vue'
import { mapStores } from "pinia"
import { useAnimeMoviesStore } from "./stores/AnimeMoviesStores"
import { useMangaReadingStore } from "./stores/MangaReadingStore"
import { usePaginationStore } from './stores/PaginationStore'
export default {

  data() {
    return {
      tab: null,
      input: null,
      page: 1,
      maxPage: 15,
    }
  },
  components: {
    NavBar,
    ChevronUpCircle
  },
  mounted() {
    this.mobailWidthPage()
    this.testPage()
    let myScroll = document.getElementById("scrollToTop");
    window.addEventListener("scroll", (ev) => {
      if (window.scrollY >= 650) {
        myScroll.style.display = "flex"
      }
      else {
        myScroll.style.display = "none"
      }
    })
  },
  methods: {
    scrollToTop() {
      window.scrollTo({ "top": 0, behavior: "smooth" });
    },
    mobailWidthPage() {
      if (window.innerWidth <= 860) {
        this.maxPage = 12
      }
      if (window.innerWidth <= 660) {
        this.maxPage = 10
      }
      if (window.innerWidth <= 580) {
        this.maxPage = 8
      }
      if (window.innerWidth <= 500) {
        this.maxPage = 7
      }
      if (window.innerWidth <= 450) {
        this.maxPage = 6
      }
    },
    async testPage() {
      if (this.$route.path === "/anime" || this.$route.path === "/") {
        await this.animeMoviesStore.fetchAnimeByPage(this.page)
        window.scrollTo({ "top": 0 });
      }
      else if (this.$route.path === "/manga") {
        await this.mangaReadingStore.fetchMangaByPage(this.page)
        window.scrollTo({ "top": 0 });
      }
      else {
        alert("page not found")
      }
    },
    testFunction() {
      if (/^[A-Za-z]+$/.test(this.input)) {
        if (this.$route.path === "/anime" || this.$route.path === "/") {
          this.animeMoviesStore.fetchAnimeBySearch(this.input)
          this.$router.push({ path: '/anime', query: { search: this.input } });
        }
        else if (this.$route.path === "/manga") {
          this.mangaReadingStore.fetchMangaBySearch(this.input)
          this.$router.push({ path: '/manga', query: { search: this.input } });
        }
        else {
          alert("Your search was not found")
        }
      }
      else {
        alert("Write only in letters, numbers are not allowed")
      }
    },
  },
  computed: mapStores(useMangaReadingStore, useAnimeMoviesStore, usePaginationStore),
}
</script>
